<?php 
/*
*Title：沉沦云QQ登陆函数
*Author:流逝中沉沦
*QQ:1178710004
*/
include("../includes/common.php");
$siteurl = ($_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://') . $_SERVER['HTTP_HOST']. '/';//获取本地域名
$allapi	 ='http://www.qqmzz.cn/';//QQ快捷登录API地址
class Oauth
{
    function __construct()
    {
        global $siteurl;
        $this->callback = $siteurl . 'admin/social.php';//登录回调地址
    }
    public function login()
    {
        global $allapi;
		
		//-------生成唯一随机串防CSRF攻击
        $state = md5(uniqid(rand(), TRUE));
		
		setcookie("Oauth_state",$state,time()+600,'/');
		
        $keysArr = array("redirect_uri" => $this->callback, "state" => $state);
		
        $login_url = $allapi . 'qqlogin/qqlogin.php?' . http_build_query($keysArr);
		
		header("Location:{$login_url}");
		
	    }
    public function callback()
    {
        global $allapi;
		
		//--------验证state防止CSRF攻击
		if ($_GET['state'] != $_COOKIE['Oauth_state']) {
			
         echo"<h2>The state does not match. You may be a victim of CSRF.</h2>";
		 
		}else{
			
        $keysArr = array("code" =>$_GET['code'], "state" =>$_COOKIE['Oauth_state'], "key" =>"zero2109877665");
		
        $token_url = $allapi . 'qqlogin/qqlogin.php?' . http_build_query($keysArr);
		
        $response = file_get_contents($token_url);
		
        $arr = json_decode($response, true);
		
        if ($arr['code']!=1) {
			
         echo'<h3>msg  :</h3>' . $arr['msg'];
        }		
        return $arr;
		}
    }
}
$Oauth = new Oauth();
header("Content-Type: text/html; charset=UTF-8");
if ($_GET['code']) {
    $array = $Oauth->callback();
    $access_token 	=	 $array['access_token'];
	$row = $DB->get_row("SELECT * FROM cly_users WHERE access_token='$access_token' limit 1");
	if($row['access_token']=='') {
		@header('Content-Type: text/html; charset=UTF-8');
		exit("<script language='javascript'>alert('该QQ未绑定用户！');history.go(-1);</script>");
	}elseif($row['uid']!=WEBID){
		exit("<script language='javascript'>alert('您不属于此站点哦！');window.location.href='./';</script>");
	}elseif($row['access_token']==$access_token){
		$user=$row['user'];
		$pass=$row['pwd'];
		$session=md5($user.$pass.$password_hash);
		$token=authcode("{$user}\t{$session}", 'ENCODE', SYS_KEY);
		setcookie("cly_token", $token, time() + 7200);
		@header('Content-Type: text/html; charset=UTF-8');
		exit("<script language='javascript'>alert('登陆授权平台成功！');window.location.href='./';</script>");
	}
} else {
	
    $Oauth->login();
}